import javax.swing.*;
import javax.swing.border.*;
import javax.swing.text.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.util.*;
import java.io.*;

public class Calculus extends JFrame
{
	private JTextField EquationField[] = new JTextField[10];
	private JButton EquationButton[] = new JButton[10];
	private Label EquationLabel[] = new Label[10];
	private GraphBox mainGraph;
	private Equation[] EquationArray = new Equation[10];
	private AnswerArea answer;

	private int logNum = 0;

	static double VERSION = 0.1;
	final public static int GRAPH = 100;
	public boolean GraphBox = false;

	public Calculus()
	{
		//Set Size, title and Default close operation
		setTitle("Calculus version: " + VERSION);
		Toolkit theKit = getToolkit();
		Dimension wndSize = theKit.getScreenSize();
		addWindowListener(new WindowHandler());

		Box EquationBoxes[] = new Box[10];

		//Set all of the labels and the TextFields and buttons
		for(int i = 0; i < 10; i++)
		{	
			EquationLabel[i] = new Label("Y" + i + "=");
			EquationField[i] = new JTextField(10);
			EquationButton[i] = new JButton("Solve");
			EquationButton[i].addActionListener(new ButtonListener(i, this));
			EquationBoxes[i] = Box.createHorizontalBox();
			EquationBoxes[i].add(EquationLabel[i]);
			EquationBoxes[i].add(EquationField[i]);
			EquationBoxes[i].add(EquationButton[i]);		
		}

		Box topGraph = Box.createHorizontalBox();
		JButton Graph = new JButton("Graph");
		Graph.addActionListener(new ButtonListener(GRAPH, this));
		topGraph.add(Graph);

		Box bottomText = Box.createHorizontalBox();
		answer = new AnswerArea(4, 10);
		answer.setEditable(false);
		bottomText.add(answer);		

		//Now to put the boxes into one big box
		Box bigLeft = Box.createVerticalBox();
		for(int i = 0; i < 10; i++)
			bigLeft.add(EquationBoxes[i]);

		//And now add big box to the main content pane
		Container content = getContentPane();
		content.setLayout(new BorderLayout());
		content.add(bigLeft, BorderLayout.WEST);
		content.add(topGraph, BorderLayout.CENTER);
		content.add(bottomText, BorderLayout.SOUTH);

		pack();

		setBounds(wndSize.width/4, wndSize.height/4, wndSize.width/2, wndSize.height/2);

		setVisible(true);
	}

	public static void main(String args[])
	{
		Calculus Main = new Calculus();
	}

	class WindowHandler extends WindowAdapter
	{
		public void windowClosing(WindowEvent e)
		{
			dispose();
			System.exit(0);
		}
	}

	class ButtonListener implements ActionListener
	{
		private int id;
		private Frame parent;

		public ButtonListener(int buttonID, Frame parent)
		{
			id = buttonID;
			this.parent = parent;
		}

		public void actionPerformed(ActionEvent e)
		{
			if((id <= 9) && (id >= 0))
			{
				SolveEquation(id);
			}
			
			switch(id)
			{
				case GRAPH:
				{
					if(!GraphBox)
					{
						mainGraph = new GraphBox(-10, 10, 1, -10, 10, 1);
						String temp;

						temp = EquationField[0].getText();
						if(temp != "")
						{
							log("Temp is " + temp);
							EquationArray[0] = new Equation(temp);
							mainGraph.setEquation(EquationArray[0]);
						}
						GraphBox = true;
					}
					else
						mainGraph.updateGraph();
				}break;
			}
		}
	}

	public static String itos(int a)
	{
		String b = new String();
		b = "" + a;
		return b;
	}

	public static String dtos(double a)
	{	
		String b = new String("" + a);
		return b;
	}

	private void SolveEquation(int i)
	{
		String temp = EquationField[i].getText();
		if(temp != "")
		{
			EquationArray[i] = new Equation(temp);
			answer.setAlignmentX(RIGHT_ALIGNMENT);
			answer.append(temp+"\n");

			double answerD = EquationArray[i].evaluateEquation(5);

			answer.setAlignmentX(RIGHT_ALIGNMENT);
			answer.append(dtos(answerD) + "\n");
		}
	}

	public boolean log(String debug)
	{
		try
		{
			String dirName = "C:\\Calculus";
			String fileName = "log.Calculus.txt";

			File myDir = new File(dirName);

			if(!myDir.exists())
				myDir.mkdir();

			else if(!myDir.isDirectory())
			{
				System.err.println(dirName + " is not a directory");
				return false;
			}

			File myFile = new File(myDir, fileName);
			myFile.createNewFile();

			BufferedWriter logStream = new BufferedWriter(
							new FileWriter(myFile.getPath(), true));

			if(logNum == 0)
				logStream.write("\n" + "\n");

			logStream.write(debug + "\n");
			logStream.close();
			logNum++;
		}
		catch(IOException e)
		{
			System.err.println("IOException " + e + " occurred");
		}

		return true;
	}
}