import java.awt.*;
import java.math.*;
import java.io.*;

public class Equation
{
	private EquationVector myEquation;
	private EquationVector tempEquation;
	private int logNum = 0;

	public Equation(String equation)
	{
		log("\nEquation constructor\n");
		equation = equation.toLowerCase();
		myEquation = new EquationVector(equation);
		tempEquation = myEquation;
		log("" + myEquation.print());
		log("" + tempEquation.print());
	}

	public boolean isValid()
	{
		log("\nisValid()\n");
		int count = 0, open = 0, close = 0;

		for(int i = 0; i < myEquation.length(); i++)
		{
			if(myEquation.charAt(i) == '(')
				open++;
			if(myEquation.charAt(i) == ')')
				close++;
		}

		if(open != close)
			return false;

		for(int i = 0; i < myEquation.length(); i++)
			if(!(isValidChar(myEquation.charAt(i))))
				count++;

		if(count > 0)
			return false;

		return true;
	}

	public static void main(String[] args)
	{
		String me = new String("x^2");
		Equation hello = new Equation(me);
		System.out.println("The answer is: " + hello.evaluateVar());
	}

	private boolean isValidChar(char a)
	{
		log("\nisValidChar(char a)\n");
		int b = a, count;
	
		if((b < 48) || (b > 57))
			if((a != '.') && (a != 'x') && (!(isOperand(a))))
				return false;

		return true;
	}

	private boolean isOperand(char a)
	{
		log("\nisOperand( " + a + " )\n");
		switch(a)
		{
			case '(':
			{
				return true;
			}
			case ')':
			{
				return true;
			}
			case '+':
			{
				return true;
			}
			case '-':
			{
				return true;
			}
			case '*':
			{
				return true;
			}
			case '^':
			{
				return true;
			}
			default: break;
		}

		return false;
	}

	public double evaluateEquation(double substitute)
	{
		log("\nevaluateInt(int substitute)\n");
		int d = -1;
		double answer;
		String a = dtos(substitute);
		log("String a is " + a);

		tempEquation = myEquation.replace('x', a);
		log("" + tempEquation.print());

		for(int i = 0; i < tempEquation.length(); i++)
		{
			log("tempEquation in evaluateInt for loop is " + tempEquation.print());
			if(tempEquation.charAt(i) == '(')
			{
				d = i;
				if((i != 0) && (tempEquation.charAt(i-1) == '^'))
				{
					log("found a ^");
					int e = 0, count = 0;

					for(int c = i; c < tempEquation.length(); c++)
						if(tempEquation.charAt(c) == '/')
							count++;

					if(count > 0)
					{
						log("found a / in the equation");
						double num1 = 0.0;
						int upper = 0, lower = 0;
						for(int c = i - 2; c >= 0; c--)
						{
							if(isOperand(tempEquation.charAt(c)))
							{
								d = c + 1;
								num1 = toNum(c+1, i-2, tempEquation);
								log("num1 is " + num1);
								break;
							}
							else if(c == 0)
							{
								d = c;
								num1 = toNum(c, i-2, tempEquation);
								log("num1 is " + num1);
								break;
							}
						}
						for(int c = i+1; c < tempEquation.length(); c++)
						{
							if(tempEquation.charAt(c) == '/')
							{
								e = c;
								upper = (int)toNum(i+1, c-1, tempEquation);
								log("found a / at " + e);
								log("upper is " + upper);
								break;
							}
						}
						for(int c = e+1; c < tempEquation.length(); c++)
						{
							if(tempEquation.charAt(c) == ')')
							{
								lower = (int)toNum(e+1, c-1, tempEquation);
								log("and lower is " + lower);
								e = c;
								break;
							}
						}
						answer = root(num1, lower, upper);
						tempEquation.chomp(d+1, e);
						tempEquation.insert(d, dtos(answer));
						log("tempEquation after doing root is " + tempEquation.print());
						i = 0;
					}
				}
			}
			else if(tempEquation.charAt(i) == ')')
			{
				answer = (int)evaluate(d, i );
				tempEquation.chomp(d, i);
				tempEquation.insert(d, dtos(answer));
				log("tempEquation after doing the () thing is " + tempEquation.print());
				i = 0;
			}
		}

		answer = evaluate(0, (tempEquation.length() - 1));

		return answer;
	}

	private double evaluate(int start, int end)
	{
		log("evaluate(" + start + ", " + end + ")\n");
	        EquationVector temp = new EquationVector();
		EquationVector temp1 = new EquationVector();

		temp.setLength((end - start) + 1);

	        double num1 = 0.0d, num2 = 0.0d, answer = 0.0d;
		int chompStart = 0, chompEnd = 0, i = 0;
		boolean negative = false;

		for(int c = start; c <= end; c++)
		{
			temp.setCharAt(i, tempEquation.charAt(c));
			i++;
		}

		log("temp.length() is " + temp.length());

		i = 0;
		for(int c = 0; c < temp.length(); c++)
			if((isOperand(temp.charAt(c))) && (!(temp.isNegativeNum(c))))
				i++;

		if(i == 0)
		{
			if(temp.isNegativeNum(0))
				answer = -(toNum(1, temp.length()-1, temp));
			else
				answer = toNum(0, temp.length()-1, temp);
			return answer;
		}

		i = 0;
		while(i < temp.length())
		    {
			if(temp.charAt(i) == '^')
			{
				for(int c = i-1; c >= 0; c--)
				{
					log("C is " + c);
					if((isOperand(temp.charAt(c))) && (!(temp.isNegativeNum(c))))
					{
						if(negative)
							num1 = -(toNum(c+1, i-1, temp));
						else
							num1 = toNum(c+1, i-1, temp);
						chompStart = c+1;
						break;
					}
					else if(temp.isNegativeNum(c))
					{
						negative = true;
					}
					else if(c == 0)
					{
						num1 = toNum(c, i-1, temp);
						chompStart = c;
						break;
					}
				}
				negative = false;
				for(int c = i+1; c < temp.length(); c++)
				{
					log("In second for loop");
					if((isOperand(temp.charAt(c))) && (!(temp.isNegativeNum(c))))
					{
						if(negative)
						        num2 = -(toNum(i+1, c-1, temp));
						else
							num2 = toNum(i+1, c-1, temp);
						chompEnd = c - 1;
						break;
					}
					else if(temp.isNegativeNum(c))
					{
						negative = true;
					}
					else if(c == (tempEquation.length() - 1))
					{
						num2 = toNum(i+1, c, temp);
						chompEnd = c;
						break;
					}
				}
				negative = false;

				answer = power(num1, num2);

				log("Num1 is " + num1 + " Num2 is " + num2);

				temp.chomp(chompStart, chompEnd);
				log("Temp after chomp is " + temp.print() + " and thats it");

				temp.insert(chompStart, dtos(answer));
				temp.setLength(resize(temp) - 1);
				log("Temp after insert is " + temp.print() + " and thats it");

				i = 0;
			}
			i++;
		}

		log("Answer after Exponents is " + answer);

		i = 0;
		
		log("Checking for * or /");
		while(i < temp.length())
		    {
			if((temp.charAt(i) == '*') || (temp.charAt(i) == '/'))
			    {
				for(int c = i - 1; c >= 0; c--)
				{
					if((isOperand(temp.charAt(c))) && (!(temp.isNegativeNum(c))))
					{
						if(negative)
							num1 = -(toNum(c+1, i-1, temp));
						else
							num1 = toNum(c+1, i-1, temp);
						chompStart = c+1;
						break;
					}
					else if(temp.isNegativeNum(c))
					{
						negative = true;
					}
					else if(c == 0)
					{
						num1 = toNum(c, i-1, temp);
						chompStart = c;
						break;
					}
				}
				negative = false;
				for(int c = i+1; c < temp.length(); c++)
				{
					if((isOperand(temp.charAt(c))) && (!(temp.isNegativeNum(c))))
					{
						if(negative)
							num2 = -(toNum(i+1, c-1, temp));
						else
							num2 = toNum(i+1, c-1, temp);
						chompEnd = c - 1;
						break;
					}
					else if(temp.isNegativeNum(c))
					{
						negative = true;
					}
					else if(c == temp.length() - 1)
					{
						num2 = toNum(i+1, c, temp);
						chompEnd = c;
						break;
					}
				}
				negative = false;
				if(temp.charAt(i) == '*')
					answer = num1 * num2;
				else
					answer = num1 / num2;

				temp.chomp(chompStart, chompEnd);
				temp.insert(chompStart, dtos(answer));
				temp.setLength(resize(temp) - 1);
				i = 0;
			}
			i++;
		}

		i = 0;

		log("Checking for + -");		
		while(i < temp.length())
		{
			if((temp.charAt(i) == '+') || (temp.charAt(i) == '-') && (!isOperand(temp.charAt(i))))
			{
				for(int c = i - 1; c >= 0; c--)
				{
					if((isOperand(temp.charAt(c))) && (!(temp.isNegativeNum(c))))
					{
						if(negative)
							num1 = -(toNum(c+1, i-1, temp));
						else
							num1 = toNum(c+1, i-1, temp);
						chompStart = c+1;
						break;
					}
					else if(temp.isNegativeNum(c))
					{
						negative = true;
					}
					else if(c == 0)
					{
						num1 = toNum(c, i-1, temp);
						chompStart = c;
						break;
					}
				}
				negative = false;
				for(int c = i+1; c < temp.length(); c++)
				{
					if((isOperand(temp.charAt(c))) && (!(temp.isNegativeNum(c))))
					{
						if(negative)
							num2 = -(toNum(i+1, c-1, temp));
						else
							num2 = toNum(i+1, c-1, temp);
						chompEnd = c - 1;
						break;
					}
					else if(temp.isNegativeNum(c))
					{
						negative = true;
					}						
					else if(c == temp.length() - 1)
					{
						num2 = toNum(i+1, c, temp);
						chompEnd = c;
						break;
					}
				}
				negative = false;
				if(temp.charAt(i) == '+')
				{
					log("Num1 is " + num1 + "\nNum2 is " + num2 + "\nAdd");
					log("ChompStart is " + chompStart + "\nChompEnd " + chompEnd);
					answer = num1 + num2;
				}
				else
				{
					log("Num1 is " + num1 + "\nNum2 is " + num2 + "\nMinus");
					answer = num1 - num2;
				}

				temp.chomp(chompStart, chompEnd);
				temp.insert(chompStart, dtos(answer));
				temp.setLength(resize(temp) - 1);
				i = 0;
			}
			i++;
		}

		return answer;
	}

	private double toNum(int start, int end, EquationVector temp)
	{
		log("\ntoNum(int start, int end, StringBuffer temp)\n");
		log("Start in toNum is " + start);
		log("End is in toNum is " + end);

		for(int i = 0; i < temp.length(); i++)
		{
			if(temp.charAt(i) == ' ')
			{
				temp.setLength(i);
				break;
			}
		}

		log("Temp in toNum is " + temp.print() + "and thats it");

		int decimalPos = -1, count = 0;
		double answer = 0.0d;

		for(int i = start; i <= end; i++)
		{
			if(temp.charAt(i) == '.')
			{
				decimalPos = i;
				count++;
			}
		}

		if(count > 1)
			log("Too many Decimals");

		if(decimalPos == -1)
		{
			int c = 1;
			for(int i = end; i >= start; i--)
			{
				answer = answer + (atoi(temp.charAt(i)) * c);
				log("Answer is " + answer);
				c *= 10;
			}
		}
		else
		{
			log("Decimal position is " + decimalPos);
			double c = 0.1d;
			for(int i = decimalPos+1; i <= end; i++)
			{
				answer = answer + (atoi(temp.charAt(i)) * c);
				log("Answer is " + answer);
				c /= 10;
			}
			int d = 1;
			for(int i = decimalPos-1; i >= start; i--)
			{
				answer = answer + (atoi(temp.charAt(i)) * d);
				d *= 10;
			}
			log("Answer is " + answer);
		}

		return answer;
	}

	private int atoi(char a)
	{
		log("\natoi(char a)\n");
		int b = a;
		return (b - 48);
	}

	private double power(double num, double exp)
	{
		log("\npower(double num, double exp)\n");
		double answer;
		if(exp == 0)
			answer = 1;
		else if(exp == 1)
			answer = num;
		else
		{
			answer = num * num;
			for(int i = 3; i <= exp; i++)
				answer *= num;
		}

		return answer;
	}

	private char itoa(int a)
	{
		log("\nitoa(int a)\n");
		return (char)(a+48);
	}

	public String itos(int a)
	{
		log("\nitos(int a)\n");
	 	String b = new String("" + a);
		return b;
	}

        public String dtos(double a)
        {
		log("\ndtos(double a)\n");
		String b = new String("" + a);
		return b;
	}

	public int resize(EquationVector a)
	{
		log("\nresize(EquationVector a)\n");
		int i = 0;
		while(i < a.length())
		{
			if(a.charAt(i) == ' ')
				break;
			i++;
		}
		return i;
	}

	public double root(double num, int rt, int exponent)
	{
		log("\nroot(double num, int rt, int exponent)\n");
		double upper = 0.0d, lower = 0.0d, answer = 0.0d, increment = 0.0d;
		int i = 0;
		num = power(num, exponent);

		log("rt is " + rt);
	
		while(true)
		{
			log("i is " + i + " and rt is " + rt);
			if(power(i, rt) > num)
			{
				log("power(i, rt) = " + power(i, rt));
				upper = i;
				lower = i - 1;
				log("upper is " + upper + " and lower is " + lower);
				break;
			}
			i++;
		}

		i = 0;
		while(i < 30)
		{
			increment = (upper - lower) / 2;

			if(power(lower + increment, rt) > num)
				upper = lower + increment;
			else if(power(lower + increment, rt) < num)
				lower = lower + increment;

			i++;
		}
		return lower;
	}

	public boolean log(String debug)
	{
		try
		{
			String dirName = "C:\\Calculus";
			String fileName = "log.equation.txt";

			File myDir = new File(dirName);

			if(!myDir.exists())
				myDir.mkdir();

			else if(!myDir.isDirectory())
			{
				System.err.println(dirName + " is not a directory");
				return false;
			}

			File myFile = new File(myDir, fileName);
			myFile.createNewFile();

			BufferedWriter logStream = new BufferedWriter(
							new FileWriter(myFile.getPath(), true));

			if(logNum == 0)
				logStream.write("\n" + "\n");

			logStream.write(debug + "\n");
			logStream.close();
			logNum++;
		}
		catch(IOException e)
		{
			System.err.println("IOException " + e + " occurred");
		}

		return true;
	}

	public String evaluateVar()
	{
		log("evaluateVar()");
		tempEquation = myEquation;
		double lead;
		String answerString = new String();

		lead = tempEquation.getLeadingPower();

		if(lead == 2)
		{
			double[] answer = new double[2];

			answer = evaluateVarQuad(tempEquation);

			answerString = answerString + answer[0] + ", " + answer[1];
		}

		return answerString;
	}

	private double[] evaluateVarQuad(EquationVector temp)
	{
		log("evaluateVarQuad( " + temp.toString() + " )");
		double a, b, c;
		double[] coef = new double[3];
		double[] answer = new double[2];

		coef = temp.getQuadCoef();

		a = coef[0];
		b = coef[1];
		c = coef[2];

		answer[0] = (-b + Math.sqrt(power(b, 2d) - (4*a*c))) / (2*a);
		answer[1] = (-b - Math.sqrt(power(b, 2d) - (4*a*c))) / (2*a);

		return answer;
	}

	class EquationVector
	{
		private StringBuffer myVector;

		public EquationVector(String a)
		{
			a = a.toLowerCase();
			myVector = toStringBuffer(a);
		}

		public EquationVector()
		{
			myVector = new StringBuffer();
		}

		public EquationVector(StringBuffer a)
		{
			myVector = a;
		}

		public void setCharAt(int a, char b)
		{
			myVector.setCharAt(a, b);
		}

		public void setLength(int a)
		{
			myVector.setLength(a);
		}

		public char charAt(int a)
		{
			return myVector.charAt(a);
		}

		public int length()
		{
			return myVector.length();
		}

		public void insert(int a, String b)
		{
			myVector.insert(a, b);
		}

		private StringBuffer toStringBuffer(String a)
		{
			StringBuffer b = new StringBuffer();
			b.setLength(a.length());
			for(int i = 0; i < a.length(); i++)
				b.setCharAt(i, a.charAt(i));

			return b;
		}

		private void chomp(int start, int end)
		{
			StringBuffer temp = new StringBuffer();
			int i, c;

			if((end - start) > 0)
			{
				if((myVector.length() - (end - start + 1)) > 0)
					temp.setLength(myVector.length() - (end - start + 1));
				else
					temp.setLength(0);

				if(temp.length() != 0)
				{
					log("temp.length in chomp is " + temp.length());
					log("myVector.length in chomp is " + myVector.length());

					for(i = 0; i < start; i++)
						temp.setCharAt(i, myVector.charAt(i));

					log("i after first run is " + i);
					c = i;			
					for(i = end+1; i < myVector.length(); i++)
					{
						temp.setCharAt(c, myVector.charAt(i));
						c++;
					}
				}
				if(temp.length() != 0)
					myVector.setLength(temp.length()-1);
				myVector = temp;
			}
			else
			{
				temp.setLength(myVector.length() - 1);

				if(start > 0)
				{
					for(i = 0; i < start; i++)
						temp.setCharAt(i, myVector.charAt(i));

					c = i;
					for(i = end+1; i < myVector.length(); i++)
					{
						temp.setCharAt(c, myVector.charAt(i));
						c++;
					}
				}
				else
				{
					c = 0;
					for(i = end+1; i < myVector.length(); i++)
					{
						if(isValidChar(myVector.charAt(i)))
						{
							temp.setCharAt(c, myVector.charAt(i));
							c++;
						}
					}
				}
				if(temp.length() != 0)
					myVector.setLength(temp.length());
				myVector = temp;
			}
		}

		private EquationVector replace(char b, String c)
		{
			log("Hello from EquationVector");
			EquationVector a = toEquation(myVector);
			for(int i = 0; i < a.length(); i++)
			{
				if(a.charAt(i) == b)
				{
					a.chomp(i, i);
					log("A after chomp is " + a.print());
					a.insert(i, c);
					log("A after insert is " + a.print());
				}
			}
			return a;
		}

		private EquationVector toEquation(StringBuffer a)
		{
			return(new EquationVector(a));
		}

		public StringBuffer print()
		{
			return myVector;
		}

		public boolean isNegativeNum(int start)
		{
			log("isNegativeNum( " + start + " )");
			if(myVector.charAt(start) != '-')
				return false;

			if(start > 0)
				if(isOperand(myVector.charAt(start - 1)))
					return true;

			return true;
		}

		public double getLeadingPower()
		{
			log("getLeadingPower()");
			double lead = -1000000000d, temp = -100000000000d;
			boolean negative = false;

			for(int i = 0; i < myVector.length(); i++)
			{
				if((myVector.charAt(i) == '^') && (i != 0))
				{
					if(myVector.charAt(i-1) == 'x')
					{
						for(int c = i+1; c < myVector.length(); c++)
						{
							if((isOperand(myVector.charAt(c))) && (!(this.isNegativeNum(c))))
							{
								if(negative)
									temp = -(toNum(i+1, c-1, this));
								else
									temp = toNum(i+1, c-1, this);
								break;
							}
							else if(this.isNegativeNum(c))
								negative = true;
							else if(c == (myVector.length()-1))
							{
								if(negative)
									temp = -(toNum(i+1, c, this));
								else
									temp = toNum(i+1, c, this);
								break;
							}
						}
						negative = false;
						if(temp > lead)
							lead = temp;
					}
				}
			}

			return lead;
		}

		public double[] getQuadCoef()
		{
			log("getQuadCoef()");
			double[] me = new double[3];
			boolean[] coef = new boolean[3];
			boolean[] exists = new boolean[3];

			int count = 0;
			boolean negative = false;

			for(int i = 0; i < myVector.length(); i++)
			{
				if((myVector.charAt(i) == '2') && (i > 1) && (myVector.charAt(i-1) == '^') && (myVector.charAt(i-2) == 'x'))
				{
					negative = false;
					exists[0] = true;
					for(int c = i > 2 ? i-3 : i-2; c >= 0; c--)
					{
						if((isOperand(myVector.charAt(c))) && (!(this.isNegativeNum(c))))
						{
							if(myVector.charAt(c+1) != 'x')
							{
								me[0] = toNum(c+1, i-3, this);
								coef[0] = true;
							}
							else
							{
								me[0] = 1;
								coef[0] = true;
							}
							break;
						}
						else if(this.isNegativeNum(c))
						{
							log("is Negative at " + c);
							negative = true;
							if((myVector.charAt(c+1) != 'x') && (!(isOperand(myVector.charAt(c+1)))))
							{
								me[0] = -(toNum(c+1, i-2, this));
								coef[0] = true;
							}
							else
							{
								me[0] = -1;
								coef[0] = true;
							}
							break;
						}
						else if(c == 0)
						{
							if(myVector.charAt(c) != 'x')
								me[0] = toNum(c, i-3, this);
							else
								me[0] = 1;
							coef[0] = true;
							break;
						}	
					}
				}
				else if((myVector.charAt(i) == 'x') && (i < myVector.length()-1) && (myVector.charAt(i+1) != '^'))
				{
					negative = false;
					exists[1] = true;
					for(int c = i-1; c >= 0; c--)
					{
						if((isOperand(myVector.charAt(c))) && (!(this.isNegativeNum(c))))
						{
							me[1] = toNum(c+1, i-1, this);
							coef[1] = true;
							break;
						}
						else if(this.isNegativeNum(c))
						{
							log("is Negative at " + c);
							negative = true;
							if((myVector.charAt(c+1) != 'x'))
							{
								me[1] = -(toNum(c+1, i-1, this));
								coef[1] = true;
							}
							break;
						}
						else if(c == 0)
						{
							if(negative)
								me[1] = -(toNum(c, i-1, this));
							else
								me[1] = toNum(c, i-1, this);
							coef[1] = true;
							break;
						}
					}
				}
			}

			int xOccur = 1;

			for(int i = 0; i < myVector.length(); i++)
			{
				xOccur = 1;

				if((isOperand(myVector.charAt(i))) && (!(this.isNegativeNum(i))))
				{
					xOccur = 0;
					negative = false;
					for(int c = i-1; c >= 0; c--)
					{
						if((isOperand(myVector.charAt(c))) && (!(this.isNegativeNum(c))) && (myVector.charAt(c) != '^'))
						{
							if(xOccur == 0)
							{
								log("found operand in string with xOccur == 0 looking for constant");
								if(negative)
									me[2] = -(toNum(c+1, i-1, this));
								else
									me[2] = toNum(c+1, i-1, this);
								coef[2] = true;
								break;
							}
						}
						else if(myVector.charAt(c) == 'x')
							xOccur++;
						else if(this.isNegativeNum(c))
						{
							log("is Negative at " + c);
							negative = true;
							if(xOccur == 0)
							{
								if((myVector.charAt(c+1) != 'x'))
								{
									me[2] = -(toNum(c+1, i-1, this));
									coef[2] = true;
								}
							}
							break;
						}
						else if(c == 0)
						{
							if(xOccur == 0)
							{
								log("found end of string with xOccur == 0 looking for constant");
								if(negative)
									me[2] = -(toNum(c, i-1, this));
								else
									me[2] = toNum(c, i-1, this);
								coef[2] = true;
								break;
							}
						}
					}
				}
				else if(this.isNegativeNum(i))
				{
					log("is Negative at " + i + " in negative section in search for constant");
					negative = true;
					xOccur = 0;
					for(int c = i+1; c < myVector.length(); c++)
					{
						if((isOperand(myVector.charAt(c))) && (myVector.charAt(c) != '^'))
						{
							if(xOccur == 0)
							{
								log("found an operand in search for constant in negative with xOccur = 0");
								me[2] = -(toNum(i+1, c-1, this));
								coef[2] = true;
							}
							break;
						}
						else if(myVector.charAt(c) == 'x')
							xOccur++;
						else if(c == myVector.length()-1)
						{
							if(xOccur == 0)
							{
								log("found an end of string in search for constant in negative with xOccur = 0");
								me[2] = -(toNum(i+1, c, this));
								coef[2] = true;
							}
							break;
						}
					}
				}
				
				if(xOccur == 0)
					break;
			}

			for(int i = 0; i < 2; i++)
			{
				if((!(coef[i])) && (exists[i]))
				{
					if(negative)
						me[i] = -1;
					else
						me[i] = 1;
				}
				else if(!(exists[i]))
					me[i] = 0;
			}

			if(!(coef[2]))
				me[2] = 0;

			log("me[0] is " + me[0] + "\nme[1] is " + me[1] + "\nme[2] is " + me[2] + "\n\n");

			return me;
		}
	}
}